#coding=utf-8
from .eBay import BEC,eBay_Token,eBay_item,eBay_order
from ..webStore_interface import BaseInterface,get_element_by_tag,parseString



class Interface(BaseInterface):
    
    
    def __init__(self,account):
        self._bec=BEC(account['Token'],account['Developer'],account['Application'],account['Certificate'],account['Runname'])
        self._account = account

    def getImgUrl(self,**args):
        return eBay_item(**self._account).get_ebay_img_url(**args)
     
    def getOrder(self,**args):
        return eBay_order(**self._account).Get_order(**args)
        
    def listOrders(self,**args):
        return eBay_order(**self._account).Get_orders(**args)
        
    def uploadTrack(self,**args):
        submit_list = args['submit_list']
        bulk_list = {}
        bulk_list['status'] = True
        for row in submit_list:
            if not bulk_list.has_key(row['id']):
                bulk_list[row['id']]  = {'status':False}
                
        for row in submit_list:
            bulk_list[row['id']]['status'] = True
            bulk_list[row['id']]['id'] = row['id']
            bulk_list[row['id']]['IdOrder'] = row['IdOrder']
            bulk_list[row['id']]['OrderID'] = row['OrderID']
            bulk_list[row['id']]['Supplier'] = row['Supplier']
            bulk_list[row['id']]['TrackingNumber'] = row['TrackingNumber']

            response_data = eBay_order(**self._account).Mark(row['OrderID'],row['Supplier'] if row['Supplier'] else None,row['TrackingNumber']  if row['TrackingNumber'] else None)
            my_dom = parseString(response_data)
            if get_element_by_tag(my_dom,"Ack") !='Success':
                bulk_list['status'] = False
                bulk_list[row['id']]['status'] = False
                bulk_list[row['id']]['ResultDescription'] = get_element_by_tag(my_dom,"LongMessage")
                bulk_list[row['id']]['ResultMessageCode'] = get_element_by_tag(my_dom,"ErrorCode")
        
        return bulk_list

    def getSessionId(self):
        return eBay_Token(**self._account).getSessionID()

    def getTokenUrl(self,**args):
        return eBay_Token(**self._account).geturl(**args)
    
    def getToken(self,**args):
        return eBay_Token(**self._account).getToken(**args)
    
        
         

    pass